/**
 * @file kywechat.h
 * @brief 
 * @author Fnoily <liuyang@kylinos.cn>
 * @version 1.0
 * @date 2021-10-26
 * 
 * Copyright: 2021,KylinSoft Co.,Ltd.
 * 
 */


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <curl/curl.h>
#include <pthread.h>
#include <sys/syslog.h>


#define REAL_WECHAT_CALL            "https://open.weixin.qq.com/connect/qrconnect?appid=wxfd0de93f7bd963be&redirect_uri=http%3A%2F%2Fwww.kylinos.cn%2F&response_type=code&scope=snsapi_login"
#define WECHAT_DEVELOP_INTERFACE    "https://lp.open.weixin.qq.com/connect/l/qrconnect?uuid=%s"
#define WECHAT_LISTEN_INTERFACE     "https://lp.open.weixin.qq.com/connect/l/qrconnect?uuid=%s&last=%d"
#define TOKEN_URL_BASE              "https://api.weixin.qq.com/sns/oauth2/access_token?appid=%s&secret=%s&code=%s&grant_type=authorization_code"
// #define TOKEN_URL_BASE              "https://api.weixin.qq.com/sns/oauth2/access_token?appid=%s&secret=%s&code=%s&grant_type=authorization_code"
#define USERINFO_BASE               "https://api.weixin.qq.com/sns/userinfo?access_token=%s&openid=%s"


#define LEN                     1024
#define URL_LEN                 2048
#define CODE_LEN                512


#define KYWECHAT_NOERR              0
#define KYWECHAT_INVALID_PARAM      1
#define KYWECHAT_INVALID_URL        2
#define KYWECHAT_NETWORK            3
#define KYWECHAT_INTERNAL           4


struct url_data {
    size_t size;
    char* data;
};


#ifdef __cplusplus
extern "C" {
#endif

/**
 * @brief 
 * @param
 */
typedef int (*wechatLoginCallBackFunction_t) (int state, char *authcode);
extern int web_flag;

/**
 * @brief 获取微信登录二维码，及后续状态
 * @param  qr_jpg           二维码图片
 * @param  callback_context 回调函数
 * @return int 
 */
int     GetLoginQR(char *qr_jpg_path, wechatLoginCallBackFunction_t callback_context);
int     GetWechatUserInfo(char *auth_code, char *open_id, char *nickname);
void* CheckWebError(void *argv);
int StopLoginQR();

#ifdef __cplusplus
}
#endif