//#include "libwechat/wechat_internal.h"
#include "libwechat/wechat_realization.h"
#include <biometric_common.h>
#include <biometric_stroge.h>
#include <biometric_version.h>
#include "id_tables.h"

#define WECHAT_NAME			"wechat_driver"
#define WECHAT_FULL_NAME	    "_wechat_certification_driver"


int ops_configure(bio_dev * dev, GKeyFile * conf)
{
    bio_print_debug("start configure");
    int ret = 0;

    // 设置驱动简称和全称
    dev->device_name    = (char*)WECHAT_NAME;
    dev->full_name      = (char*)WECHAT_FULL_NAME;

    // 设置驱动所支持的USB设备的ID表
    // 支持的ID表在id_tables.h中
    dev->usb_info.id_table = wechat_driver_id_table;
    // 保留字
    dev->usb_info.driver_data = 0;

    dev->ops_configure = ops_configure;

    ret = wechat_ops_configure(dev, conf);

    return ret;
}
